;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@                 S t a r F i e l d   S c r e e n s a v e r                  @
;@                                                                            @
;@             (c) 2004-2007 by Prodatron / SymbiosiS (Jrn Mika)             @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

relocate_start

;==============================================================================
;### CODE-TEIL ################################################################
;==============================================================================

;### PROGRAMM-KOPF ############################################################

prgdatcod       equ 0           ;Lnge Code-Teil (Pos+Len beliebig; inklusive Kopf!)
prgdatdat       equ 2           ;Lnge Daten-Teil (innerhalb 16K Block)
prgdattra       equ 4           ;Lnge Transfer-Teil (ab #C000)
prgdatorg       equ 6           ;Original-Origin
prgdatrel       equ 8           ;Anzahl Eintrge Relocator-Tabelle
prgdatstk       equ 10          ;Lnge Stack (Transfer-Teil beginnt immer mit Stack)
prgdatcrn       equ 12          ;Lnge gecrunchte Daten
prgdatctp       equ 14          ;Crunch-Typ (0=ungepackt, 1=SymbOS, 2=eigene Routine)
prgdatnam       equ 15          ;Programm-Name (32+1[0] Zeichen)
prgdatidn       equ 48          ;"SymExe10"
prgdatcex       equ 56          ;zustzlicher Speicher fr Code-Bereich
prgdatdex       equ 58          ;zustzlicher Speicher fr Data-Bereich
prgdattex       equ 60          ;zustzlicher Speicher fr Transfer-Bereich
prgdatres       equ 62          ;*reserviert* (28 bytes)
prgdatism       equ 90          ;Icon (klein)
prgdatibg       equ 109         ;Icon (gross)
prgdatlen       equ 256         ;Datensatzlnge

prgpstdat       equ 6           ;Adresse Daten-Teil
prgpsttra       equ 8           ;Adresse Transfer-Teil
prgpstspz       equ 10          ;zustzliche Prozessnummern (4*1)
prgpstbnk       equ 14          ;Bank (1-8)
prgpstmem       equ 48          ;zustzliche Memory-Bereiche (8*5)
prgpstnum       equ 88          ;Programm-Nummer
prgpstprz       equ 89          ;Prozess-Nummer

prgcodbeg   dw prgdatbeg-prgcodbeg  ;Lnge Code-Teil
            dw prgtrnbeg-prgdatbeg  ;Lnge Daten-Teil
            dw prgtrnend-prgtrnbeg  ;Lnge Transfer-Teil
prgdatadr   dw #1000                ;Original-Origin                    POST Adresse Daten-Teil
prgtrnadr   dw relocate_count       ;Anzahl Eintrge Relocator-Tabelle  POST Adresse Transfer-Teil
prgprztab   dw prgstk-prgtrnbeg     ;Lnge Stack                        POST Tabelle Prozesse
            dw 0                    ;Lnge gecrunchte Daten
prgbnknum   db 0                    ;Crunch-Typ                         POST Bank-Nummer
            db "Starfield Screensaver":ds 32-21:db 0  ;Name
prgmemtab   db "SymExe10"           ;SymbOS-EXE-Kennung                 POST Tabelle Speicherbereiche
            dw 0                    ;zustzlicher Code-Speicher
            dw 0                    ;zustzlicher Data-Speicher
            dw 0                    ;zustzlicher Transfer-Speicher
            ds 28                   ;*reserviert*
prgicnsml   db 2,8,8,#F0,#F0,#E1,#D0,#B0,#F4,#F2,#F0,#F0,#B4,#F0,#F0,#B4,#F8,#F0,#70
prgicnbig   db 6,24,24,#F0,#F0,#F0,#F0,#F0,#F0,#B0,#F0,#F0,#F0,#F0,#F0,#F2,#F0,#F0,#D0,#F0,#F0,#F0,#F0,#F0,#F2,#F0,#F0,#F0,#D0,#F0,#F0,#B4,#F0,#F0,#F1,#F0,#F0,#F0,#B0,#F0,#F0,#F0,#F0,#F0,#F8,#E0,#F0,#E1,#F2,#F0,#F0,#F0,#F8,#F1,#F0
            db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#71,#78,#F0,#F0,#74,#F1,#F0,#F0,#B2,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#F0,#F0,#F0,#E2,#F0,#B4,#F2,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F8,#F4,#F0,#F0,#F0,#F4,#70
            db #D2,#F0,#F0,#F8,#B4,#F0,#F0,#F0,#E0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F1,#F0,#F0,#F0,#F0,#F8,#F0,#70,#F0,#F0,#F0,#70,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0


;### SCREEN-SAVER BILD ########################################################
db 16,64,40
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#70,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#D0,#F0,#F0,#F0,#F0,#F1,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#70,#F0,#F0,#F1,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F4,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#D0,#F0
db #B2,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#B4,#F0,#F0,#F0,#F0,#F0,#F4,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F4,#F0,#E1,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#E1,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F1,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#70,#F0,#F0,#F8,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F4,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#D1,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E3,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F8,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F1,#F0,#F0,#F0,#F0,#F8,#F0,#F0,#F0,#F1,#70
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#B4,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#7C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F2,#F0,#F0,#F8,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F1,#F0,#F0,#B4,#F0,#F0,#B4,#F0,#F0,#F0,#F0,#F0,#F4
db #F0,#F0,#F0,#D0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#D0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F4,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#D0,#F0,#F0,#F0
db #F0,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #E0,#F0,#F0,#F0,#F0,#F0,#F0,#F2,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F0,#F0,#F0,#D0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#F2,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0
db #F0,#F0,#F0,#F0,#D0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0

;### PRGPRZ -> Programm-Prozess
dskprzn     db 2
sysprzn     db 3
windatprz   equ 3   ;Prozenummer
windatsup   equ 51  ;Nummer des Superfensters+1 oder 0
prgwin      db 0    ;Nummer des Haupt-Fensters
cfgwin      db 0    ;Nummer des Config-Fensters

cfgdat  db "3DSF"   ;ID
cfganz  db 32       ;Anzahl Sterne (nur 16, 32 oder 64 mglich)
cfgspd  db 2        ;Sternen-Speed (1-8)
cfgcol  db 2        ;0=Rot, 1=Grn, 2=Blau
cfglok  db 0        ;1=System sperren
cfgtmp  ds 64


prgprz  ld a,(prgprzn)
        ld (prgwindat+windatprz),a
        ld (configwin+windatprz),a
        call sysptc

        ld b,10                 ;Maximal 10 Zyklen auf Init-Message warten
prgprz1 push bc
        rst #30
        ld a,(prgprzn)
        db #dd:ld l,a
        db #dd:ld h,-1
        ld iy,prgmsgb
        rst #18
        db #dd:dec l
        pop bc
        jr z,prgprz2
        djnz prgprz1
        call prgani             ;Animation starten und anschlieend beenden
        jp prgend

prgprz0 ld a,(prgprzn)
        db #dd:ld l,a
        db #dd:ld h,-1
        ld iy,prgmsgb
        rst #08                 ;Schlafen und auf Kommando warten
        db #dd:dec l
        jr nz,prgprz0
prgprz2 ld iy,prgmsgb
        ld a,(iy+0)
        cp 1
        jp c,prgend     ;0=Ende
        jr z,prgini     ;1=Init (p1=bank, p2/3=adr)
        cp 3
        jr z,prgcfg     ;3=Config
        jr nc,prgprz3
        call prgani     ;2=Animation starten
        jr prgprz0
prgprz3 cp MSR_DSK_WCLICK       ;*** Fenster-Aktion wurde geklickt
        jr nz,prgprz0
        ld a,(iy+2)
        cp DSK_ACT_CLOSE        ;*** Close wurde geklickt
        jp z,cfgcnc
        cp DSK_ACT_CONTENT      ;*** Inhalt wurde geklickt
        jr nz,prgprz0
        ld l,(iy+8)
        ld h,(iy+9)
        ld a,h
        or l
        jr z,prgprz0
        jp (hl)

;### PRGINI -> Config-Parameter holen
prgini  ld a,(prgbnknum)
        add a:add a:add a:add a
        or (iy+1)
        ld l,(iy+2)
        ld h,(iy+3)
        ld de,cfgtmp
        ld bc,64
        rst #20:dw jmp_bnkcop
        ld a,(cfgtmp+0):cp "3":jr nz,prgini0
        ld a,(cfgtmp+1):cp "D":jr nz,prgini0
        ld a,(cfgtmp+2):cp "S":jr nz,prgini0
        ld a,(cfgtmp+3):cp "F":jr nz,prgini0
        ld hl,(cfgtmp+4)
        ld (cfganz),hl
        ld (cfganzt),hl
        ld hl,(cfgtmp+6)
        ld (cfgcol),hl
        ld (cfgcolt),hl
prgini0 jp prgprz0

;### PRGCFG -> Config einstellen
prgcfg  db #dd:ld a,h
        ld (cfgprz),a
        call cfgopn
        jp prgprz0

;### PRGANI -> Animation durchfhren
mospos  ds 4
prgani  ld c,MSC_DSK_WINOPN
        ld a,(prgbnknum)
        ld b,a
        ld de,prgwindat
        call msgsnd             ;Fenster aufbauen
prgani1 rst #30
        call msgget             ;Message holen -> IXL=Status, IXH=Absender-Proze
        jr nc,prgani1
        cp MSR_DSK_WOPNER
        ret z                   ;kein Speicher fr Fenster -> Animation abbrechen
        cp MSR_DSK_WOPNOK
        jr nz,prgani1           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (prgwin),a           ;Fenster wurde geffnet -> Nummer merken
        call staini             ;*** Animations-Init
        call fulakt
        jr c,prgani3
        rst #30
        rst #30
        rst #30
        rst #20:dw jmp_mosget
        ld (mospos+0),de
        ld (mospos+2),hl
prgani0 call msgget
        jr c,prgani2
        call staani             ;*** Animation, wenn keine Message vorliegt
        rst #20:dw jmp_mosget   ;DE=XPos, HL=YPos
        ld bc,(mospos+2)        ;test, ob Maus bewegt wurde
        or a
        sbc hl,bc
        jr nz,prgani4
        ld hl,(mospos+0)
        ex de,hl
        sbc hl,de
        jr z,prgani0
        jr prgani4
prgani2 cp MSR_DSK_WCLICK       ;*** Fenster-Aktion wurde geklickt
        jr nz,prgani0
        ld a,(iy+2)
        cp DSK_ACT_KEY
        jr nz,prgani0
prgani4 call prgani3            ;*** Taste wurde gedrckt -> Animation beenden
        jp fuloff
prgani3 ld a,(prgwin)           ;Fenster schlieen
        ld b,a
        ld c,MSC_DSK_WINCLS
        jp msgsnd

;### PRGEND -> Programm beenden
prgend  ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        ld (iy+0),MSC_SYS_PRGEND
        ld a,(prgcodbeg+prgpstnum)
        ld (iy+1),a
        rst #10
prgend0 rst #30
        jr prgend0


;==============================================================================
;### CONFIG-ROUTINEN ##########################################################
;==============================================================================

cfgprz  db 0

;### CFGOPN -> ffnet Config-Window
cfgopn  ld a,(cfgwin)
        or a
        ret nz                  ;Fenster bereits offen
        ld c,MSC_DSK_WINOPN
        ld a,(prgbnknum)
        ld b,a
        ld de,configwin
        call msgsnd             ;Fenster aufbauen
cfgopn1 rst #30
        call msgget             ;Message holen -> IXL=Status, IXH=Absender-Proze
        jr nc,cfgopn1
        cp MSR_DSK_WOPNER
        ret z                   ;kein Speicher fr Fenster -> Animation abbrechen
        cp MSR_DSK_WOPNOK
        jr nz,cfgopn1           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (cfgwin),a           ;Fenster wurde geffnet -> Nummer merken
        ret

;### CFGCLO -> Schliet Config-Window
cfgclo  ld a,(cfgwin)
        or a
        ret z                   ;Fenster nicht offen
        ld c,MSC_DSK_WINCLS
        ld b,a
        xor a
        ld (cfgwin),a
        jp msgsnd               ;Fenster schlieen

;### CFGOKY -> User hat OK geclickt
cfgoky  call cfgclo
        ld hl,(cfganzt):ld (cfganz),hl
        ld hl,(cfgcolt):ld (cfgcol),hl
        ld a,(prgbnknum)
        ld b,a
        ld a,(cfgprz)
        or a
        jp z,prgprz0
        ld c,MSR_SAV_CONFIG
        ld de,cfgdat
        call msgsnd1
        jp prgprz0

;### CFGCNC -> User hat Cancel geclickt
cfgcnc  call cfgclo
        ld hl,(cfganz):ld (cfganzt),hl
        ld hl,(cfgcol):ld (cfgcolt),hl
        jp prgprz0


;==============================================================================
;### STARFIELD-ROUTINEN #######################################################
;==============================================================================

;### STAINI -> Initialisiert Stern-Speicher
;### Verndert  F,BC,DE,IX
staini  ld ix,stamem            ;Stern-Daten vorbereiten
        ld de,stalen
        ld a,(cfganz)
        ld (stadrw0+2),a
        ld (stadrw2+2),a
        ld b,a
        cp 32
        ld a,64
        ld c,4
        jr c,staini1
        ld c,2
        jr z,staini1
        dec c
staini1 ld (ix+staxps),0
        ld (ix+stayps),0
        ld (ix+stazps),a
        ld (ix+staadr+0),#ff
        ld (ix+staadr+1),#ff
        add c
        add ix,de
        djnz staini1
        ld a,(prgbnknum)        ;Datenstruktur fr 16K-Routine vorbereiten
        ld (stadat),a
        ld hl,stadrw
        ld (stadat+1),hl
        ret

;### STAANI -> Fhrt eine Animations-Phase durch
staani  ld ix,stamem
        ld a,(cfganz)
        ld b,a
staani1 push bc
        push ix
        ld a,(cfgspd)
        neg
        add (ix+stazps)
        cp 64
        jr nc,staani2
        call stanew             ;E=XPos (-128 bis +127), D=YPos (-128 bis +127)
        ld (ix+staxps),e
        ld (ix+stayps),d
        ex de,hl
        ld a,127
        jr staani3
staani2 ld l,(ix+staxps)
        ld h,(ix+stayps)
staani3 ld (ix+stazps),a
        ld c,a
        call staclc             ;Stern berechnen
        call staplt
        pop ix
        ld (ix+stapos+0),l
        ld (ix+stapos+1),h
        ld (ix+stamsk),e
        ld (ix+stapen),d
        ld bc,stalen
        add ix,bc
        pop bc
        djnz staani1
staani4 jp staani5
staani5 ld ix,stadat            ;Sterne plotten
        ld hl,jmp_bnk16c
        rst #28
        ret

;### STANEW -> Generiert Position fr neuen Stern
;### Ausgabe    E=XPos (-128 bis +127), D=YPos (-128 bis +127)
;### Verndert  AF,BC,HL
rndtab              ;enthlt 128 Random-Werte
db 180,136,148,74,77,198,3,194,208,181,11,105,220,202,95,246,223,14,243,93,134,196,13,151,119,76,159,165,67,71,212,211,150,252,233
db 58,177,250,62,136,27,255,173,4,147,25,26,204,72,11,75,97,77,242,250,102,71,41,41,165,104,105,182,83,162,53,47,149,20,117,231,66
db 201,96,74,235,161,160,109,25,143,177,233,213,5,139,234,110,173,128,131,118,90,103,69,14,62,250,15,99,93,125,39,121,65,160,138,40
db 240,167,129,99,27,200,117,192,152,213,4,53,18,26,84,32,0,137,168,139

stanew  ld a,r
        and 127
        ld c,a
        ld b,0
        ld hl,rndtab
        add hl,bc
        call stanew1
        ld e,a
        inc c
        ld hl,rndtab
        add hl,bc
        call stanew1
        ld d,a
        ret
stanew1 ld a,(hl)
        cp 224
        jr c,stanew2
        sub 224
        ld d,a
        add a
        add a
        add a
        add d
stanew2 add 16
        ret

;### STACLC -> Berechnet 2D-Position von Stern
;### Eingabe    L=XPos (-128 bis +127), H=YPos (-128 bis +127), C=ZPos (127 bis 64)
;### Ausgabe    L=XPos (-128 bis +127), H=YPos (-128 bis +127), C=Farbe (0-7)
;### Verndert  AF,B,DE
staclcs db 0
staclct db 255,251,247,243,239,236,233,229,226,223,220,217,214,211,209,206,203,201,198,196,194,191,189,187,185,183,181,179,177,175,173,171
        db 169,167,166,164,162,161,159,158,156,155,153,152,150,149,147,146,145,143,142,141,140,139,137,136,135,134,133,132,131,130,129,128

staclc  ld a,h
        call staclc1        ;Y umrechnen
        push af
        ld a,l
        call staclc1        ;X umrechnen
        pop hl
        ld l,a
        ld a,127            ;Farbe aus Z berechnen
        sub c
        srl a
        srl a
        srl a
        ld c,a              ;Farbe = (127-z)/8
        ret
staclc1 push hl
        push bc
        bit 7,a
        jr z,staclc2
        ld (staclcs),a
        neg                 ;Koordinate immer Positiv
staclc2 ld e,a              ;DE=Koordinate
        ld d,0
        ld b,d
        ld hl,staclct-64
        add hl,bc
        ld a,(hl)           ;A=64*256/(Z+1)
        call clcm16
        ld a,h
        ld hl,staclcs
        inc (hl):dec (hl)
        jr z,staclc3
        ld (hl),0
        neg                 ;Vorzeichen zurckholen
staclc3 pop bc
        pop hl
        ret

;### STAPLT -> Berechnet Plot-Daten fr Stern
;### Eingabe    L=XPos (-128 bis +127), H=YPos (-128 bis +127), C=Farbe (0-7)
;### Ausgabe    HL=Adresse, E=Lsch-Maske, D=Pen
;### Verndert  AF,BC,D,IX
stapltc db #0c,#cc,#30,#f0,#3c,#fc,#03,#c3  ;,#0f,#cf,#33,#f3,#3f,#ff
stapltm db #22,#33,#44,#55,#66,#77,#88,#99
stapltp db #22,#22,#66,#66,#ee,#ee,#ff,#ff

staplt  db #dd:ld l,c
        db #dd:ld h,0
stapltz ld bc,stapltc+1
        add ix,bc
        ld a,l
staplta add 80
stapltb cp 160
        jr nc,staplt2
        ld e,a          ;E=X (0-159)
        ld a,h
staplte add 100
stapltf cp 200
        jr nc,staplt2
        ld l,a          ;L=Y (0-199)
stapltg call getadr     ;HL=Adresse, A=Pixeloffset, ZF=Pixel (1=links, 0=rechts)
stapltx ld e,#aa
        jr nz,staplt1
staplty ld e,#55
staplt1 ld a,e
        rrca
        and (ix+0)
        ld d,a
        ret
staplt2 ld hl,#ffff
        ret
staplt3 pop bc
        call getadrc
        ld de,#f00f
        jr z,staplt4
        ld de,#0ff0
staplt4 ld a,(ix+0)
        and d
        ld d,a
        ret

;### GETADRB -> Berechnet Bildschirm-Adresse (MSX)
;### Eingabe    E=XPos, L=YPos
;### Ausgabe    HL=Adresse, A=Pixeloffset, ZF=Pixel (1=links, 0=rechts)
;### Veraendert F,BC,DE
getadrb srl l
        ld h,l
        rr e
        ld l,e
        ld a,0
        adc 0
        ret

;### GETADRC -> Berechnet Bildschirm-Adresse (PCW)
;### Eingabe    E=XPos (0-179), L=YPos (0-175)
;### Ausgabe    HL=Adresse, A=Pixeloffset, ZF=Pixel (1=links, 0=rechts)
;### Veraendert F,BC,DE
getadrc ld h,0
        add hl,hl
        ld bc,getadr1
        add hl,bc
        ld c,(hl)
        inc hl
        ld h,(hl)
        ld l,c          ;hl=lineadr
        ld a,e
        ld c,e
        and #fe
        add a
        ld e,a
        ld a,0
        adc 0
        ld d,a
        add hl,de
        add hl,de
        ld a,c
        and 1
        ret

getadr1
dw #C220,#C221,#C222,#C223,#C224,#C225,#C226,#C227,#C4F0,#C4F1,#C4F2,#C4F3,#C4F4,#C4F5,#C4F6,#C4F7,#C7C0,#C7C1,#C7C2,#C7C3,#C7C4,#C7C5,#C7C6,#C7C7,#CA90,#CA91,#CA92,#CA93,#CA94,#CA95,#CA96,#CA97
dw #CD60,#CD61,#CD62,#CD63,#CD64,#CD65,#CD66,#CD67,#D030,#D031,#D032,#D033,#D034,#D035,#D036,#D037,#D300,#D301,#D302,#D303,#D304,#D305,#D306,#D307,#D5D0,#D5D1,#D5D2,#D5D3,#D5D4,#D5D5,#D5D6,#D5D7
dw #D8A0,#D8A1,#D8A2,#D8A3,#D8A4,#D8A5,#D8A6,#D8A7,#DB70,#DB71,#DB72,#DB73,#DB74,#DB75,#DB76,#DB77,#DE40,#DE41,#DE42,#DE43,#DE44,#DE45,#DE46,#DE47,#E110,#E111,#E112,#E113,#E114,#E115,#E116,#E117
dw #E3E0,#E3E1,#E3E2,#E3E3,#E3E4,#E3E5,#E3E6,#E3E7,#E6B0,#E6B1,#E6B2,#E6B3,#E6B4,#E6B5,#E6B6,#E6B7,#E980,#E981,#E982,#E983,#E984,#E985,#E986,#E987,#EC50,#EC51,#EC52,#EC53,#EC54,#EC55,#EC56,#EC57
dw #EF20,#EF21,#EF22,#EF23,#EF24,#EF25,#EF26,#EF27,#F1F0,#F1F1,#F1F2,#F1F3,#F1F4,#F1F5,#F1F6,#F1F7,#F4C0,#F4C1,#F4C2,#F4C3,#F4C4,#F4C5,#F4C6,#F4C7,#F790,#F791,#F792,#F793,#F794,#F795,#F796,#F797
dw #FA60,#FA61,#FA62,#FA63,#FA64,#FA65,#FA66,#FA67,#FD30,#FD31,#FD32,#FD33,#FD34,#FD35,#FD36,#FD37

;### GETADR -> Berechnet Bildschirm-Adresse (CPC)
;### Eingabe    E=XPos, L=YPos
;### Ausgabe    HL=Adresse, A=Pixeloffset, ZF=Pixel (1=links, 0=rechts)
;### Veraendert F,BC,DE
getadr  ld h,0
        add hl,hl
        ld bc,getadr0
        add hl,bc
        ld c,(hl)
        inc hl
        ld h,(hl)
        ld l,c
        ld a,e
        ld d,0
        srl e
        add hl,de
        and 1
        ret

getadr0                         ;Zeilenstart-Adressen
dw #C000,#C800,#D000,#D800,#E000,#E800,#F000,#F800,#C050,#C850,#D050,#D850,#E050,#E850,#F050,#F850,#C0A0,#C8A0,#D0A0,#D8A0,#E0A0,#E8A0,#F0A0,#F8A0,#C0F0
dw #C8F0,#D0F0,#D8F0,#E0F0,#E8F0,#F0F0,#F8F0,#C140,#C940,#D140,#D940,#E140,#E940,#F140,#F940,#C190,#C990,#D190,#D990,#E190,#E990,#F190,#F990,#C1E0,#C9E0
dw #D1E0,#D9E0,#E1E0,#E9E0,#F1E0,#F9E0,#C230,#CA30,#D230,#DA30,#E230,#EA30,#F230,#FA30,#C280,#CA80,#D280,#DA80,#E280,#EA80,#F280,#FA80,#C2D0,#CAD0,#D2D0
dw #DAD0,#E2D0,#EAD0,#F2D0,#FAD0,#C320,#CB20,#D320,#DB20,#E320,#EB20,#F320,#FB20,#C370,#CB70,#D370,#DB70,#E370,#EB70,#F370,#FB70,#C3C0,#CBC0,#D3C0,#DBC0
dw #E3C0,#EBC0,#F3C0,#FBC0,#C410,#CC10,#D410,#DC10,#E410,#EC10,#F410,#FC10,#C460,#CC60,#D460,#DC60,#E460,#EC60,#F460,#FC60,#C4B0,#CCB0,#D4B0,#DCB0,#E4B0
dw #ECB0,#F4B0,#FCB0,#C500,#CD00,#D500,#DD00,#E500,#ED00,#F500,#FD00,#C550,#CD50,#D550,#DD50,#E550,#ED50,#F550,#FD50,#C5A0,#CDA0,#D5A0,#DDA0,#E5A0,#EDA0
dw #F5A0,#FDA0,#C5F0,#CDF0,#D5F0,#DDF0,#E5F0,#EDF0,#F5F0,#FDF0,#C640,#CE40,#D640,#DE40,#E640,#EE40,#F640,#FE40,#C690,#CE90,#D690,#DE90,#E690,#EE90,#F690
dw #FE90,#C6E0,#CEE0,#D6E0,#DEE0,#E6E0,#EEE0,#F6E0,#FEE0,#C730,#CF30,#D730,#DF30,#E730,#EF30,#F730,#FF30,#C780,#CF80,#D780,#DF80,#E780,#EF80,#F780,#FF80

;### CLCM16 -> Multipliziert zwei Werte (16bit)
;### Eingabe    A=Wert1, DE=Wert2
;### Ausgabe    HL=Wert1*Wert2 (16bit)
;### Veraendert AF,DE
clcm16  ld hl,0
        or a
clcm161 rra
        jr nc,clcm162
        add hl,de
clcm162 sla e
        rl d
        or a
        jr nz,clcm161
        ret

;### SYSPTC -> Patched Routinen fr MSX/PCW-Betrieb
;msx
sysptcm dw staplta,#ff00+128,  stapltb,#ff00+255,  staplte,#ff00+106,  stapltf,#ff00+212
        dw stapltg,getadrb
        dw stapltx,#ff00+#1e,  staplty,#ff00+#e1
        dw stapltz,stapltm
        dw fulclr,fulclr2,     staani4,stadrwb,    fulakt0,fulakt4,    fuloff0,fuloff4
        dw 0
;pcw
sysptcp dw staplta,#ff00+90,  stapltb,#ff00+180,  staplte,#ff00+88,  stapltf,#ff00+176
        dw stapltg,staplt3
        dw stapltz,stapltp
        dw fulclr,fulclr4,     fulakt0,fulakt5,    fuloff0,fuloff5,  staplt2,#c000
        dw 0

sysptc  ld hl,jmp_sysinf        ;Computer-Typ holen
        ld de,256*1+5
        ld ix,cfgcpctyp
        ld iy,66+2+6+8
        rst #28
        ld a,(cfgcpctyp)
        and 15
        cp 8
        ret c
        ld bc,4
        cp 12
        ld ix,sysptcm-4
        jr c,sysptc1
        ld ix,sysptcp-4
sysptc1 add ix,bc
        ld l,(ix+0)
        ld h,(ix+1)
        ld e,(ix+2)
        ld d,(ix+3)
        ld a,l
        or h
        ret z
        inc hl
        ld (hl),e
        inc d
        jr z,sysptc1
        dec d
        inc hl
        ld (hl),d
        jr sysptc1


;==============================================================================
;### FULLSCREEN-ROUTINEN ######################################################
;==============================================================================

fulbuf  ds 17*2+1
fulcolr dw #000,#000,#800,#f00,#f80,#ff0,#ff8,#fff,#fff,#fff:ds 15
fulcolg dw #000,#000,#080,#0f0,#8f0,#ff0,#ff8,#fff,#fff,#fff:ds 15
fulcolb dw #000,#000,#008,#00f,#08f,#0ff,#8ff,#fff,#fff,#fff:ds 15
fulblk  ds 17*2

fulakta db #06,#62,#1f,#80,#01,#ec,#0f,#01,#2a

;### FULAKT -> Stoppt Desktop und aktiviert Fullscreen Mode
;### Ausgabe    CF=1 -> nicht mglich, da Desktop bereits eingefroren ist
fulakt  ld a,(prgwin)           ;Desktop abschalten
        ld d,a
        ld e,-1
        ld a,DSK_SRV_DSKSTP
        call dsksrv
        dec d
        scf
        ret z
        ld a,DSK_SRV_MODGET     ;Mode merken
        call dsksrv
        ld ix,fulbuf+1
        ld (ix-1),e
        ld b,17                 ;Farben merken
fulakt1 push bc
        push ix
        ld a,17
        sub b
        ld e,a
        ld a,DSK_SRV_COLGET
        call dsksrv
        pop ix
        pop bc
        ld (ix+0),d
        ld (ix+1),l
        inc ix:inc ix
        djnz fulakt1
        ld ix,fulblk
        call fuloff1
        rst #30
        call fulclr             ;Bildschirm lschen
        ld a,(cfgcol)
        cp 1
        ld ix,fulcolr
        jr c,fulakt2
        ld ix,fulcolg
        jr z,fulakt2
        ld ix,fulcolb
fulakt2 call fuloff1            ;Farben setzen
fulakt0 jp fulakt3
fulakt3 ld b,#7f                ;Mode 0 setzen (CPC)
        ld a,#8c+0
        out (c),a
        or a
        ret
fulakt4 ld hl,fulakta           ;Mode 0 setzen (MSX)
        ld bc,256*9+0
        call vdpreg
fulakt5 or a
        ret

;### FULOFF -> Deaktiviert Fullscreen Mode und kehrt zum Desktop zurck
fuloff  call fulclr
fuloff0 call fuloff3
        ld ix,fulbuf+1
        call fuloff1
        ld a,DSK_SRV_DSKCNT     ;Desktop einschalten
        jp dsksrv
fuloff1 ld b,17                 ;Farben setzen
fuloff2 push bc
        push ix
        ld a,17
        sub b
        ld e,a
        ld a,DSK_SRV_COLSET
        ld d,(ix+0)
        ld l,(ix+1)
        call dsksrv
        pop ix
        pop bc
        inc ix:inc ix
        djnz fuloff2
        ret
fuloff3 ld b,#7f                ;Mode wiederherstellen (CPC)
        ld a,(fulbuf)
        add a,#8c
        out (c),a
        ret
fuloff4 ld a,(fulbuf)           ;Mode wiederherstellen (MSX)
        add 128
        ld e,a
        ld a,DSK_SRV_MODSET
        jp dsksrv
fuloff5 ret                     ;Mode wiederherstellen (PCW)

;### FULCLR -> Lscht den kompletten Bildschirm
fulclr  jp fulclr1
fulclr1 ld hl,stacln            ;Bildschirm lschen (CPC)
        ld (stadat+1),hl
        ld ix,stadat
        ld hl,jmp_bnk16c
        rst #28
        ld hl,stadrw
        ld (stadat+1),hl
        ret
fulclr2 ld hl,#0000             ;Bildschirm lschen (MSX)
        call vdpwrt
        ld bc,#6a*2
        xor a
fulclr3 out (#98),a
        djnz fulclr3
        dec c
        jr nz,fulclr3
        ret
fulclr4 xor a                   ;Bildschirm lschen (PCW)
        ld hl,#c000
        ld b,l
        rst #20:dw jmp_bnkwbt
        ex de,hl
        ld hl,#c000
        ld bc,16384-1
        rst #20:dw jmp_bnkcop
        ld a,#10
        ld hl,#c000
        ld de,#4000
        ld bc,7200-1
        rst #20:dw jmp_bnkcop
        ret

;### STADRWB -> Plottet alle Sterne (MSX)
;### Verndert  AF,BC,DE,HL,IX,IXL
stadrwb ld ix,stamem
stadrw2 db #fd:ld l,0
        ld bc,stalen
stadrw3 ld l,(ix+staadr+0)
        ld h,(ix+staadr+1)
        call vdpwrt
        xor a
        out (#98),a
        ld l,(ix+stapos+0)
        ld h,(ix+stapos+1)
        ld (ix+staadr+0),l
        ld (ix+staadr+1),h
        call vdpwrt
        ld a,(ix+stapen)
        out (#98),a
        add ix,bc
        db #fd:dec l
        jr nz,stadrw3
        ret

;### VDPREG -> Setzt eine Anzahl an VDP-Registern
;### Eingabe    HL=Register-Data, C=erstes Register, B=Anzahl Register
;### Verndert  AF,BC,HL
vdpreg  ld a,c
        di
        out (#99),a
        ld  a,17+128
        ei
        out (#99),a
        ld  c,#9B
        otir
        ret

;### VDPWRT -> VDP-Adresse zum Schreiben setzen
;### Eingabe    HL=Adresse
;### Verndert  AF,HL
vdpwrt  call vdpwai
        xor a
        rlc h
        rla
        rlc h
        rla
        srl h
        srl h
        di
        out (#99),a
        ld a,14+128
        out (#99),a
        ld a,l
        nop
        out (#99),a
        ld a,h
        or 64
        ei
        out (#99),a
        ret

;### VDPWAI -> Wartet, bis VDP fr Kommando bereit ist
;### Verndert  AF
vdpwai  ld  a,2
        di
        out (#99),a
        ld a,15+128
        out (#99),a
        in a,(#99)
        rra
        ld a,0
        out (#99),a
        ld a,15+128
        ei
        out (#99),a
        jr c,vdpwai
        ret


;==============================================================================
;### SUB-ROUTINEN #############################################################
;==============================================================================

;### DSKSRV -> Desktop Service nutzen
;### Eingabe    A=Dienst, DE,HL = Parameter
;### Ausgabe    DE,HL = Parameter
dsksrvn db 0
dsksrv  ld c,MSC_DSK_DSKSRV
        ld (dsksrvn),a
        push af
        call SyDesktop_SendMessage
        pop af
        cp 1
        jr z,dsksrv1
        cp 3
        jr z,dsksrv1
        cp 5
        ret nz
dsksrv1 call SyDesktop_WaitMessage
        cp MSR_DSK_DSKSRV
        jr nz,dsksrv1
        ld a,(dsksrvn)
        cp (iy+1)
        jr nz,dsksrv1
        ld e,(iy+2)
        ld d,(iy+3)
        ld l,(iy+4)
        ld h,(iy+5)
        ret
SyDesktop_SendMessage
        ld iy,prgmsgb
        ld (iy+0),c
        ld (iy+1),a
        ld (iy+2),e
        ld (iy+3),d
        ld (iy+4),l
        ld (iy+5),h
        db #dd:ld h,2       ;2 is the number of the desktop manager process
        ld a,(prgprzn)
        db #dd:ld l,a
        rst #10
        ret
SyDesktop_WaitMessage
        ld iy,prgmsgb
SyDWMs1 db #dd:ld h,2       ;2 is the number of the desktop manager process
        ld a,(prgprzn)
        db #dd:ld l,a
        rst #08             ;wait for a desktop manager message
        db #dd:dec l
        jr nz,SyDWMs1
        ld a,(iy+0)
        ret

;### MSGGET -> Message fr Programm abholen
;### Ausgabe    CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgget  ld a,(prgprzn)
        db #dd:ld l,a           ;IXL=Rechner-Proze-Nummer
        db #dd:ld h,2
        ld iy,prgmsgb           ;IY=Messagebuffer
        rst #18                 ;Message holen -> IXL=Status, IXH=Absender-Proze
        or a
        db #dd:dec l
        ret nz
        ld iy,prgmsgb
        ld a,(iy+0)
        or a
        jp z,prgend
        scf
        ret

;### MSGSND -> Message an Desktop-Prozess senden
;### Eingabe    C=Kommando, B/E/D/L/H=Parameter1/2/3/4/5
msgsnd  ld a,(dskprzn)
msgsnd1 db #dd:ld h,a
        ld a,(prgprzn)
        db #dd:ld l,a
        ld iy,prgmsgb
        ld (iy+0),c
        ld (iy+1),b
        ld (iy+2),e
        ld (iy+3),d
        ld (iy+4),l
        ld (iy+5),h
        rst #10
        ret


;==============================================================================
;### DATEN-TEIL ###############################################################
;==============================================================================

prgdatbeg

configtit   db "3D Starfield Screensaver Setup",0
configtxt0a db "Settings",0
configtxt0b db "About",0
configtxt0c db "3D Starfield Simulation for SymbOS",0
configtxt0d db "(c)oded 2005 by Prodatron/SymbiosiS",0
configtxt1  db "Number of Stars",0
configtxt1a db "16",0,"32",0,"64",0
configtxt2  db "Flight speed",0
configtxt2a db "1",0, "2",0, "4",0, "6",0
configtxt3  db "Star colour",0
configtxt3a db "Blue",0
configtxt3b db "Red",0
configtxt3c db "Green",0

prgtxtok    db "OK",0
prgtxtcnc   db "Cancel",0

staxps  equ 0
stayps  equ 1
stazps  equ 2
staclr  equ 3   ;alte Lschmaske
staadr  equ 4   ;alte Adresse
stapen  equ 6   ;Pen
stamsk  equ 7   ;neue Maske
stapos  equ 8   ;neue Adresse
stalen  equ 10
stamax  equ 64
stamem  ds stalen*stamax

;### STACLN -> Lscht den Bildschirm
stacln  ld hl,#c000
        ld de,#c001
        ld (hl),l
        ld bc,#3fff
        ldir
        ret

;### STADRW -> Plottet alle Sterne (CPC)
;### Verndert  AF,BC,DE,HL,IX,IXL
stadrw  ld ix,stamem
        db #dd:ld a,h
        res 7,a
        set 6,a
        db #dd:ld h,a
stadrw0 db #fd:ld l,0
        ld bc,stalen
stadrw1 ld l,(ix+staadr+0)
        ld h,(ix+staadr+1)
        ld a,(ix+staclr)
        and (hl)
        ld (hl),a
        ld l,(ix+stapos+0)
        ld h,(ix+stapos+1)
        ld (ix+staadr+0),l
        ld (ix+staadr+1),h
        ld a,(ix+stamsk)
        ld (ix+staclr),a
        ld d,(ix+stapen)
        and (hl)
        or d
        ld (hl),a
        add ix,bc
        db #fd:dec l
        jr nz,stadrw1
        ret


;==============================================================================
;### TRANSFER-TEIL ############################################################
;==============================================================================

prgtrnbeg
;### PRGPRZS -> Stack fr Programm-Prozess
        ds 128
prgstk  ds 6*2
        dw prgprz
prgprzn db 0
prgmsgb ds 14

stadat  ds 5

;### DUMMY-FENSTER ############################################################

prgwindat dw #0001,4,1000,1000,100,100,0,0,100,100,100,100,100,100,prgicnsml,prgwinobj,0,0,prgwingrp,0,0:ds 136+14
prgwingrp db 1,0:dw prgwinobj,0,0,0,0,0,0
prgwinobj dw 00,255*256+00,00,0,0,100,100,0     ;00=Hintergrund

;### CONFIG FENSTER ###########################################################

configwin   dw #1501,0,059,035,200,102,0,0,200,102,200,102,200,102,prgicnsml,configtit,0,0,configgrp,0,0:ds 136+14
configgrp   db 21,0:dw configdat,0,0,256*21+20,0,0,00
configdat
dw      00,         0,2,          0,0,1000,1000,0       ;00=Hintergrund
dw      00,255*256+ 3,configdsc0a,00, 01,200,45,0       ;01=Rahmen "Settings"
dw      00,255*256+ 1,configdsc1, 08, 11, 54, 8,0       ;02=Beschreibung "Anzahl"
dw      00,255*256+18,configrad1a,78, 11, 20, 8,0       ;03=Radio 16
dw      00,255*256+18,configrad1b,98, 11, 20, 8,0       ;04=Radio 32
dw      00,255*256+18,configrad1c,118,11, 20, 8,0       ;05=Radio 64
dw      00,255*256+ 1,configdsc2, 08, 21, 54, 8,0       ;06=Beschreibung "Speed"
dw      00,255*256+18,configrad2a,78, 21, 20, 8,0       ;07=Radio 1
dw      00,255*256+18,configrad2b,98, 21, 20, 8,0       ;08=Radio 2
dw      00,255*256+18,configrad2c,118,21, 20, 8,0       ;09=Radio 4
dw      00,255*256+18,configrad2d,138,21, 20, 8,0       ;10=Radio 6
dw      00,255*256+ 1,configdsc3, 08, 31, 54, 8,0       ;11=Beschreibung "Farbe"
dw      00,255*256+18,configrad3a,78, 31, 32, 8,0       ;12=Radio Blue
dw      00,255*256+18,configrad3b,110,31, 32, 8,0       ;13=Radio Red
dw      00,255*256+18,configrad3c,142,31, 32, 8,0       ;14=Radio Green
dw      00,255*256+ 3,configdsc0b,00, 45,200,42,0       ;15=Rahmen "Misc"
dw      00,255*256+ 8,prgicnbig  ,08, 55, 24,24,0       ;16=Grafik Screensaver
dw      00,255*256+ 1,configdsc0c,37, 57,144, 8,0       ;17=Beschreibung "About 1"
dw      00,255*256+ 1,configdsc0d,37, 67,144, 8,0       ;18=Beschreibung "About 2"
dw  cfgoky,255*256+16,prgtxtok,   99, 87, 48,12,0       ;19="Ok"    -Button
dw  cfgcnc,255*256+16,prgtxtcnc, 149, 87, 48,12,0       ;20="Cancel"-Button

configdsc0a dw configtxt0a,2+4
configdsc0b dw configtxt0b,2+4
configdsc0c dw configtxt0c,2+4
configdsc0d dw configtxt0d,2+4

configdsc1  dw configtxt1,2+4
configrad1k ds 4
configrad1a dw cfganzt,configtxt1a+0,256*16+2+4,configrad1k
configrad1b dw cfganzt,configtxt1a+3,256*32+2+4,configrad1k
configrad1c dw cfganzt,configtxt1a+6,256*64+2+4,configrad1k

configdsc2  dw configtxt2,2+4
configrad2k ds 4
configrad2a dw cfgspdt,configtxt2a+0,256*1+2+4,configrad2k
configrad2b dw cfgspdt,configtxt2a+2,256*2+2+4,configrad2k
configrad2c dw cfgspdt,configtxt2a+4,256*4+2+4,configrad2k
configrad2d dw cfgspdt,configtxt2a+6,256*6+2+4,configrad2k

configdsc3  dw configtxt3,2+4
configrad3k ds 4
configrad3a dw cfgcolt,configtxt3a,  256*2+2+4,configrad3k
configrad3b dw cfgcolt,configtxt3b,  256*0+2+4,configrad3k
configrad3c dw cfgcolt,configtxt3c,  256*1+2+4,configrad3k

cfganzt db 32       ;Anzahl Sterne (nur 16, 32 oder 64 mglich)
cfgspdt db 2        ;Sternen-Speed (1-8)
cfgcolt db 2        ;0=Rot, 1=Grn, 2=Blau
cfglokt db 0        ;1=System sperren

cfgcpctyp   db 0

prgtrnend

relocate_table
relocate_end
