;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@                          D i s k D e D u m p e r                           @
;@                                                                            @
;@             (c) 2004-2007 by Prodatron / SymbiosiS (Jrn Mika)             @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


relocate_start


;==============================================================================
;### CODE-TEIL ################################################################
;==============================================================================

;### PROGRAMM-KOPF ############################################################

prgdatcod       equ 0           ;Lnge Code-Teil (Pos+Len beliebig; inklusive Kopf!)
prgdatdat       equ 2           ;Lnge Daten-Teil (innerhalb 16K Block)
prgdattra       equ 4           ;Lnge Transfer-Teil (ab #C000)
prgdatorg       equ 6           ;Original-Origin
prgdatrel       equ 8           ;Anzahl Eintrge Relocator-Tabelle
prgdatstk       equ 10          ;Lnge Stack (Transfer-Teil beginnt immer mit Stack)
prgdatcrn       equ 12          ;Lnge gecrunchte Daten
prgdatctp       equ 14          ;Crunch-Typ (0=ungepackt, 1=SymbOS, 2=eigene Routine)
prgdatnam       equ 15          ;Programm-Name (32+1[0] Zeichen)
prgdatidn       equ 48          ;"SymExe10"
prgdatcex       equ 56          ;zustzlicher Speicher fr Code-Bereich
prgdatdex       equ 58          ;zustzlicher Speicher fr Data-Bereich
prgdattex       equ 60          ;zustzlicher Speicher fr Transfer-Bereich
prgdatres       equ 62          ;*reserviert* (28 bytes)
prgdatism       equ 90          ;Icon (klein)
prgdatibg       equ 109         ;Icon (gross)
prgdatlen       equ 256         ;Datensatzlnge

prgpstdat       equ 6           ;Adresse Daten-Teil
prgpsttra       equ 8           ;Adresse Transfer-Teil
prgpstspz       equ 10          ;zustzliche Prozessnummern (4*1)
prgpstbnk       equ 14          ;Bank (1-8)
prgpstmem       equ 48          ;zustzliche Memory-Bereiche (8*5)
prgpstnum       equ 88          ;Programm-Nummer
prgpstprz       equ 89          ;Prozess-Nummer

prgcodbeg   dw prgdatbeg-prgcodbeg  ;Lnge Code-Teil
            dw prgtrnbeg-prgdatbeg  ;Lnge Daten-Teil
            dw prgtrnend-prgtrnbeg  ;Lnge Transfer-Teil
prgdatadr   dw #1000                ;Original-Origin                    POST Adresse Daten-Teil
prgtrnadr   dw relocate_count       ;Anzahl Eintrge Relocator-Tabelle  POST Adresse Transfer-Teil
prgprztab   dw prgstk-prgtrnbeg     ;Lnge Stack                        POST Tabelle Prozesse
            dw 0                    ;Lnge gecrunchte Daten
prgbnknum   db 0                    ;Crunch-Typ                         POST Bank-Nummer
            db "DiskDeDumper":ds 20:db 0    ;Name
prgmemtab   db "SymExe10"           ;SymbOS-EXE-Kennung                 POST Tabelle Speicherbereiche
            dw 4096-256             ;zustzlicher Code-Speicher
            dw 0                    ;zustzlicher Data-Speicher
            dw 0                    ;zustzlicher Transfer-Speicher
            ds 28                   ;*reserviert*
prgicnsml   db 2,8,8,#C0,#00,#A0,#00,#A0,#00,#D1,#FB,#11,#FF,#51,#FB,#71,#FF,#11,#1F
prgicnbig   db 6,24,24,#07,#0F,#0F,#0F,#0F,#08,#78,#C3,#78,#96,#96,#84,#69,#69,#C3,#D2,#96,#84,#69,#69,#C3,#D2,#96,#84,#69,#69,#C3,#1E,#96,#84,#69,#69,#78,#1E,#B4,#0C,#69,#69,#3C,#96,#E1,#0C,#69,#69,#0F,#D2,#B4,#0C,#69,#69,#C3,#D2
            db #96,#84,#69,#69,#C3,#D2,#96,#84,#78,#C3,#78,#96,#96,#84,#07,#0F,#0F,#0F,#0F,#08,#00,#60,#00,#F0,#F0,#F0,#00,#60,#00,#F7,#FF,#FE,#00,#60,#00,#F5,#F9,#FA,#00,#60,#00,#F7,#F9,#FE,#00,#60,#80,#F7,#F9,#FE,#00,#60,#C0,#F7
            db #FF,#FE,#00,#70,#E0,#F7,#F9,#FE,#00,#70,#E0,#F7,#F9,#FE,#00,#00,#C0,#F7,#FF,#FE,#00,#00,#80,#F4,#F0,#F2,#00,#00,#00,#E5,#0F,#7A,#00,#00,#00,#F0,#F0,#F0


;### PRGPRZ -> Programm-Prozess
dskprzn     db 2
sysprzn     db 3
windatprz   equ 3   ;Prozenummer
windatsup   equ 51  ;Nummer des Superfensters+1 oder 0
prgwin      db 0    ;Nummer des Haupt-Fensters

prgprz  ld a,(prgprzn)
        ld (prgwindat+windatprz),a

        call prgpar

        ld c,MSC_DSK_WINOPN
        ld a,(prgbnknum)
        ld b,a
        ld de,prgwindat
        call msgsnd             ;Fenster aufbauen
prgprz1 call msgdsk             ;Message holen -> IXL=Status, IXH=Absender-Proze
        cp MSR_DSK_WOPNER
        jp z,prgend             ;kein Speicher fr Fenster -> Proze beenden
        cp MSR_DSK_WOPNOK
        jr nz,prgprz1           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (prgwin),a           ;Fenster wurde geffnet -> Nummer merken

prgprz0 call msgget
        jr nc,prgprz0
        cp MSR_SYS_SELOPN       ;*** Browse-Fenster wurde geschlossen
        jp z,prgbrc
        cp MSR_DSK_WCLICK       ;*** Fenster-Aktion wurde geklickt
        jr nz,prgprz0
        ld a,(iy+2)             ;*** HAUPT-FENSTER
        cp DSK_ACT_CLOSE        ;*** Close wurde geklickt
        jp z,prgend
        cp DSK_ACT_CONTENT      ;*** Inhalt wurde geklickt
        jr nz,prgprz0
prgprz2 ld l,(iy+8)
        ld h,(iy+9)
        ld a,l
        or h
        jr z,prgprz0
        ld a,(iy+3)             ;A=Klick-Typ (0/1/2=Maus links/rechts/doppelt, 7=Tastatur)
        jp (hl)

;### PRGEND -> Programm beenden
prgend  ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        ld (iy+0),MSC_SYS_PRGEND
        ld a,(prgcodbeg+prgpstnum)
        ld (iy+1),a
        rst #10
prgend0 rst #30
        jr prgend0

;### PRGINF -> Info-Fenster anzeigen
prginf  ld hl,prgmsginf         ;*** Info-Fenster
        ld b,1+128
prginf0 ld (prgmsgb+1),hl
        ld a,(prgbnknum)
        ld c,a
        ld (prgmsgb+3),bc
        ld a,MSC_SYS_SYSWRN
prginf1 ld (prgmsgb),a
        call prginf2
        jp prgprz0
prginf2 ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        rst #10
        ret


;==============================================================================
;### FDC-DISKETTEN-ROUTINEN ###################################################
;==============================================================================

;Fehler-Codes
stoerrsec   equ 0       ;Fehler beim Sektor lesen/schreiben
stoerrwrp   equ 1       ;Schreibschutz vorhanden, es kann nicht auf den Datentrger geschrieben werden
stoerrrdy   equ 2       ;Gert nicht bereit
stoerrend   equ 3       ;DSK-Dateiende vorzeitig erreicht
stoerrtyp   equ 4       ;falsche DSK-Version

fdc_motor_on    equ #fa7f   ;Port+Code zum Anschalten des Motors
fdc_motor_off   equ #fa7e   ;Port+Code zum Ausschalten des Motors
fdc_status      equ #fb7e   ;FDC Hauptstatus Register
fdc_data        equ #fb7f   ;FDC Daten Register
fdc_rdywait     equ 6*50*2  ;maximal 2 Sekunden warten (6 Halts*50 Frames*2 Sekunden)

fdc_cmd_specify equ #03     ;Laufwerksdaten festlegen
fdc_cmd_st3     equ #04     ;Status-Register 3 lesen
fdc_cmd_recal   equ #07     ;Recalibrate (Track 0 anfahren)
fdc_cmd_st0     equ #08     ;Status-Register 0 lesen
fdc_cmd_seek    equ #0f     ;Track anfahren
fdc_cmd_write   equ #45     ;Sector schreiben
fdc_cmd_read    equ #46     ;Sector lesen
fdc_cmd_id      equ #4a     ;Sector-ID lesen
fdc_cmd_format  equ #4d     ;Track formatieren

fdc_res_st0     equ 0       ;Status Register 0
fdc_res_st1     equ 1       ;Status Register 1
fdc_res_st2     equ 2       ;Status Register 2
fdc_res_track   equ 3       ;Track-Nummer
fdc_res_head    equ 4       ;Kopf-Nummer
fdc_res_sector  equ 5       ;Sektor-ID
fdc_res_ssize   equ 6       ;Sektor-Gre

fdcresult   ds 7            ;Result-Buffer

;### FDCRDY -> Warten, bis FDC fr Befehl bereit ist
;### Eingabe    BC=Port des Data-Registers
;### Verndert  AF
fdcrdy  dec c               ;1
fdcrdy1 in a,(c)            ;4
        jp p,fdcrdy1        ;3
        inc c               ;1
        ret                 ;3 12

;### FDCCMD -> Kommando an den FDC senden
;### Eingabe    A=Kommando
;### Ausgabe    BC=Port des Data-Registers
;### Verndert  AF,E
fdccmd  ld bc,fdc_data      ;3
;### FDCSND -> Byte an den FDC senden
;### Eingabe    A=Byte, BC=Port des Data-Registers
;### Verndert  AF,E
fdcsnd  ld e,a              ;1
        call fdcrdy         ;5+12
        out (c),e           ;4
        ret                 ;3 28

;### FDCST3 -> Status-Register 3 lesen
;### Eingabe    A=Laufwerk/Kopf
;### Ausgabe    A=Statusregister 3, BC=Port des Data-Registers
;### Verndert  F,DE
fdcst3  and 3
        ld d,a
        ld a,fdc_cmd_st3
        call fdccmd
        ld a,d
        call fdcsnd
;### FDCRCV -> Byte vom FDC holen
;### Eingabe    BC=Port des Data-Registers
;### Ausgabe    A=Byte
;### Verndert  F
fdcrcv  call fdcrdy
        in a,(c)
        ret

;### FDCMON -> Laufwerk starten (Motor einschalten und auf Bereitschaft warten)
;### Eingabe    A=Laufwerk/Kopf, L=Modus (0=Lesen, 1=Schreiben)
;### Ausgabe    CF=0 -> alles ok
;###            CF=1 -> A=Fehler-Code (...)
;### Verndert  AF,BC,DE,HL
fdcmon  and 3
        ld h,a              ;H=Laufwerk
        ld bc,fdc_motor_on
        out (c),c           ;Motor einschalten
        ld bc,fdc_rdywait   ;nur bestimte Zeit warten, dann Error
fdcmon1 push bc
        ld a,h
        call fdcst3
        pop bc
        inc l:dec l
        jr z,fdcmon2
        bit 6,a
        jr nz,fdcmon3       ;Schreibschutz vorhanden, obwohl geschrieben werden soll -> Fehler
fdcmon2 or a
        bit 5,a
        ret nz
        rst #30
        dec bc
        ld a,c
        or b
        jr nz,fdcmon1
        ld a,stoerrrdy      ;Laufwerk auch nach 5 Sekunden nicht bereit -> Fehler
        scf
        ret
fdcmon3 ld a,stoerrwrp
        scf
        ret

;### FDCMOF -> Laufwerk stoppen
;### Verndert  BC
fdcmof  ld bc,fdc_motor_off
        out (c),c
        ret

;### FDCTRK -> Track anfahren (Laufwerk mu bereits gestartet worden sein)
;### Eingabe    A=Laufwerk/Kopf, E=Track (Bit7=1 -> DoubleStep)
;### Verndert  AF,BC,DE,HL
fdctrk  bit 7,e
        jr z,fdctrk1
        sla e               ;Doublestep -> physikalische Track-Nummer verdoppeln
fdctrk1 and 3
        ld d,a
        ld a,e
        or a
        jr z,fdctrk4        ;falls Track 0 -> Recalibrierung durchfhren
        ld l,e              ;*** Track X anfahren
        ld a,fdc_cmd_seek   ;Kommando
        di
        call fdccmd
        ld a,d              ;Laufwerk
        call fdcsnd
        ld a,l              ;Track
        call fdcsnd
        ei
fdctrk3 ld a,fdc_cmd_st0    ;*** Status abfragen
        call fdcsnd
        call fdcrcv
        ld l,a              ;L=Status 0 Register
        call fdcrcv         ;A=Spurnummer
        bit 5,l
        ret nz              ;Laufwerk bereit -> fertig
        rst #30
        jr fdctrk3
fdctrk4 di
        call fdctrk5        ;*** Track 0 anfahren (Recalibrierung)
        ei
        call fdctrk3
        di
        call fdctrk5
        ei
        jr fdctrk3
fdctrk5 ld a,fdc_cmd_recal  ;*** Recalibrierungs-Kommando
        call fdccmd         ;Kommando
        ld a,d              ;Laufwerk
        jp fdcsnd

;### FDCWRT -> Sektor schreiben
;### Eingabe    A=Laufwerk/Kopf, IX=Sektor-Daten, L=Gap3, DE=Quelladresse
;### Ausgabe    CF=0 -> alles ok
;###            CF=1 -> A=Fehler-Code (...)
;### Verndert  AF,BC,DE
fdcwrt  push de
        push af
        di
        ld a,fdc_cmd_write
        call fdccmd         ;Commando senden
        pop af
        call fdcsnd         ;Laufw.+Kopf senden
        ld a,(ix+dsk_sec_track)
        call fdcsnd         ;Track
        ld a,(ix+dsk_sec_side)
        call fdcsnd         ;Kopf
        ld a,(ix+dsk_sec_secid)
        ld h,a
        call fdcsnd         ;SectorID erste
        ld a,(ix+dsk_sec_secsize)
        call fdcsnd         ;Gre
        ld a,h
        call fdcsnd         ;SectorID letzte
        ld a,l
        call fdcsnd         ;Gap3
        ld a,#ff
        call fdcsnd         ;SektorLnge senden (da SektorGre > 0, mu hier #ff gesendet werden)
        pop hl
        jr fdcwrt2
fdcwrt1 ld a,(hl)           ;2
        out (c),a           ;4 kein OUTI wegen existierender Emulator-Inkompatibilitt
        inc hl              ;2
fdcwrt2 dec c               ;1
fdcwrt3 in a,(c)            ;4
        jp p,fdcwrt3        ;3
        inc c               ;1
        and #20             ;2
        jr nz,fdcwrt1       ;3 22
        jr fdcres

;### FDCFRM -> Track formatieren
;### Eingabe    A=Laufwerk/Kopf, L=Sektorgre, H=Anzahl Sektoren, E=Gap3, D=Fllbyte, IX=Sektordaten
;### Ausgabe    CF=0 -> alles ok
;###            CF=1 -> A=Fehler-Code (...)
;### Verndert  AF,BC,DE,HL,IX
fdcfrm  push de
        push af
        di
        ld a,fdc_cmd_format
        call fdccmd         ;Commando senden
        pop af
        and 3
        or #48
        call fdcsnd         ;Laufwerk senden
        ld a,l
        call fdcsnd         ;Sektor-Gre senden
        ld a,h
        call fdcsnd         ;Anzahl Sektoren senden
        pop hl
        ld a,l
        call fdcsnd         ;Gap3 senden
        ld a,h
        call fdcsnd         ;Fllbyte senden
        jr fdcfrm2
fdcfrm1 ld a,(ix+0)
        out (c),a
        inc ix
fdcfrm2 dec c
fdcfrm3 in a,(c)
        jp p,fdcfrm3
        inc c
        and #20
        jr nz,fdcfrm1
        jp fdcres

;### FDCRES -> Result-Phase durchfhren
;### Eingabe    BC=Port des Data-Registers
;### Ausgabe    (fdcresult)=Buffer mit Ergebnissen (7 Bytes), CF=1 -> A=Fehler-Code (...)
;### Verndert  AF,DE
fdcres  ei
        push hl
        ld hl,fdcresult
        ld d,7
fdcres1 call fdcrcv
        ld (hl),a
        inc hl
        dec d
        jr nz,fdcres1
        pop hl
        ld a,(fdcresult+fdc_res_st0)
        ld d,a
        bit 3,d
        ld a,stoerrrdy
        scf
        ret nz              ;Gert nicht bereit -> Fehler
        ld a,d
        and #c0
        ret z               ;kein Fehler -> alles ok
        cp #40
        jr nz,fdcres2
        ld a,(fdcresult+fdc_res_st1)
        bit 7,a
        ret nz              ;End Of Track Fehler -> beim CPC normale, also alles ok
fdcres2 ld a,stoerrsec      ;sonstiges -> Fehler beim Sector laden/schreiben
        scf
        ret


;==============================================================================
;### SUB-ROUTINEN #############################################################
;==============================================================================

;### PRGPAR -> Angehngtes DSK suchen
prgpar  ld hl,(prgcodbeg)       ;nach angehngtem DSK suchen
        ld de,prgcodbeg
        dec h
        add hl,de               ;HL=CodeEnde=Pfad
        ld b,255
prgpar1 ld a,(hl)
        or a
        jp z,prgprz0
        cp 32
        jr z,prgpar2
        inc hl
        djnz prgpar1
        jp prgprz0
prgpar2 inc hl
        ld de,prginpsrcb
        ld bc,255
        ldir
        ld ix,prginpsrc
        jp strinp

;### STRINP -> Initialisiert Textinput (abhngig vom String, den es bearbeitet)
;### Eingabe    IX=Control
;### Ausgabe    HL=Stringende (0), BC=Lnge (maximal 255)
;### Verndert  AF
strinp  ld l,(ix+0)
        ld h,(ix+1)
        call strlen
        ld (ix+8),c
        ld (ix+4),c
        xor a
        ld (ix+2),a
        ld (ix+6),a
        ret

;### STRLEN -> Ermittelt Lnge eines Strings
;### Eingabe    HL=String
;### Ausgabe    HL=Stringende (0), BC=Lnge (maximal 255)
;### Verndert  -
strlen  push af
        xor a
        ld bc,255
        cpir
        ld a,254
        sub c
        ld c,a
        dec hl
        pop af
        ret

;### PRGCOP -> Kopiert DSK auf Diskette
dsktyp  db 0        ;DSK-Typ (0=Einfach, 1=Extended)
dsktrk  db 0        ;Anzahl Tracks
dsksid  db 0        ;Anzahl Seiten
dsktrl  ds 168+1    ;Tracklngen
dsksec  ds 4*11     ;Sektor-Daten
dskgp3  db 0        ;Gap3-Lnge
dskdrs  db 0        ;Drive+Side

dsk_dsk_tracks  equ #30
dsk_dsk_sides   equ #31
dsk_dsk_lenone  equ #33
dsk_dsk_length  equ #34

dsk_trk_track   equ #10
dsk_trk_side    equ #11
dsk_trk_secsize equ #14
dsk_trk_secnums equ #15
dsk_trk_gap3len equ #16
dsk_trk_fllbyte equ #17
dsk_trk_secinfo equ #18

dsk_sec_track   equ #0
dsk_sec_side    equ #1
dsk_sec_secid   equ #2
dsk_sec_secsize equ #3
dsk_sec_fdcsr1  equ #4
dsk_sec_fdcsr2  equ #5

dsktxtstd   db "MV - CPCEMU Disk-File",13,10,"Disk-Info",13,10
dsktxtext   db "EXTENDED CPC DSK File",13,10,"Disk-Info",13,10
dsktxtlen   equ 34

prgcops db 0    ;Source-Handler

prgcopt dw 0    ;Track(Low) + Seite(High)
prgcopi db 0,16 ;ID, Gre

prgcop  ld a,-1                     ;*** Init
        ld (prgcops),a
        ld hl,(prginpsidb)
        call clchex
        jr nc,prgcopd
        ld a,#fe            ;ungltige ID -> #FE als Standard nehmen
prgcopd ld (prgcopi),a

        ld a,(dskdrv)               ;*** Diskettenlaufwerk starten
        ld l,1
        call fdcmon
        jp c,prgerr

        ld hl,prginpsrcb            ;*** DSK ffnen
        ld a,(prgbnknum)
        db #dd:ld h,a
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOPN
        jp c,prgerr         ;Fehler beim ffnen
        ld (prgcops),a

        ld de,(prgbnknum)           ;*** Disk-Info lesen
        ld hl,dskbuffer
        ld bc,256           ;Eingabe -> A=Dateihandler, HL=Zieladresse, E=Bank (0-8), BC=Anzahl Bytes
        call syscll         ;Ausgabe -> CF=0 -> alles ok, BC=Anzahl gelesener Bytes, ZF=1 -> es wurde alles geladen
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        jp c,prgerr         ;Fehler beim Lesen
        jp nz,prgerr

        ld de,dsktxtstd             ;*** DSK-Typ bestimmen
        call prgcop1
        jr z,prgcop3
        ld de,dsktxtext
        call prgcop1
        scf
        ld a,stoerrtyp
        jp nz,prgerr        ;Fehler beim DSK-Typ
        ld a,1
prgcop3 ld (dsktyp),a
        or a
        ld ix,dskbuffer
        ld a,(ix+dsk_dsk_tracks)    ;Anzahl Tracks
        ld (dsktrk),a
        ld a,(ix+dsk_dsk_sides)     ;Anzahl Seiten
        ld (dsksid),a
        ld iy,prgtxtsta11
        jr nz,prgcop4       ;Tracklngen
        ld iy,prgtxtsta10
        ld a,(ix+dsk_dsk_lenone)
        ld (dsktrl),a
        ld hl,dsktrl
        ld de,dsktrl+1
        jr prgcop5
prgcop4 ld hl,dskbuffer
        ld bc,dsk_dsk_length
        add hl,bc
        ld de,dsktrl
prgcop5 ld bc,168
        ldir
        ld (prgobjsta1),iy  ;Infos anzeigen
        ld a,(dsktrk)
        call clcdez
        ld (iy+10),l
        ld (iy+11),h
        ld a,(dsksid)
        add "0"
        ld (iy+21),a
        ld hl,prgtxtsta21
        ld (prgobjsta2),hl
        ld e,15
        call prgerr3

        ld c,0
prgcop6 ld b,0                      ;*** Track-Loop
prgcop7 ld (prgcopt),bc             ;*** Side-Loop
        ld a,c
        call clcdez
        ld (prgtxtsta21+14),hl
        ld a,b
        add "0"
        ld (prgtxtsta21+23),a
        call prgerr2
        ld bc,(prgcopt)     ;C=Track (0-83), B=Side (0-1)
        ld e,c
        ld a,(dskdrv)
        sla b
        sla b
        or b
        ld (dskdrs),a
        call fdctrk                 ;*** Track anfahren
        ld bc,(prgcopt)     ;C=Track (0-83), B=Side (0-1)
        ld a,(dsksid)
        dec a
        ld a,c
        jr z,prgcop8
        add a
prgcop8 add b               ;A=logischer Track
        ld l,a
        ld h,0
        ld de,dsktrl
        add hl,de
        ld a,(hl)
        or a
        jp z,prgcopb        ;Track ist leer -> optional als nicht vorhanden formatieren

        ld a,(prgcops)              ;*** Track-Info lesen
        ld de,(prgbnknum)
        ld hl,dskbuffer
        ld bc,256           ;Eingabe -> A=Dateihandler, HL=Zieladresse, E=Bank (0-8), BC=Anzahl Bytes
        call syscll         ;Ausgabe -> CF=0 -> alles ok, BC=Anzahl gelesener Bytes, ZF=1 -> es wurde alles geladen
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        jp c,prgerr         ;Fehler beim Lesen
        jp nz,prgerr

        ld hl,dskbuffer-4
        ld de,dsk_trk_secinfo
        add hl,de
        ld de,dsksec
        ld a,11
prgcop9 ld bc,4
        add hl,bc
        ldir
        dec a
        jr nz,prgcop9
        ld ix,dskbuffer
        ld l,(ix+dsk_trk_secsize)
        ld h,(ix+dsk_trk_secnums)
        push hl
        ld e,(ix+dsk_trk_gap3len)
        ld a,e
        ld (dskgp3),a
        ld d,(ix+dsk_trk_fllbyte)
        ld ix,dsksec
        ld a,(dskdrs)
        call fdcfrm
        pop bc              ;B=Anzahl Sektoren, C=Sektorlnge
        jp c,prgerr         ;Fehler beim Formatieren

        ld ix,dsksec                ;*** Sektor-Loop
prgcopa push bc
        push ix
        ld a,(prgcops)              ;*** Sektor lesen
        ld de,(prgbnknum)
        ld hl,dskbuffer
        ld b,c
        ld c,0              ;Eingabe -> A=Dateihandler, HL=Zieladresse, E=Bank (0-8), BC=Anzahl Bytes
        call syscll         ;Ausgabe -> CF=0 -> alles ok, BC=Anzahl gelesener Bytes, ZF=1 -> es wurde alles geladen
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        pop ix
        pop bc
        jp c,prgerr         ;Fehler beim Lesen
        jp nz,prgerr
        push bc
        push ix
        ld a,(dskdrs)               ;*** Sektor schreiben
        ld hl,(dskgp3)
        ld de,dskbuffer
        call fdcwrt
        pop ix
        pop bc
        jr c,prgerr         ;Fehler beim Schreiben
        ld de,4
        add ix,de
        djnz prgcopa
        jr prgcopc

prgcopb ld a,(unftyp)               ;*** Track "unformatieren"
        or a
        jr z,prgcopc        ;Skip -> weiter
        ld a,(dskdrs)
        ld hl,1*256+16
        ld e,256*#e5+42
        ld ix,prgcopt
        call fdcfrm
        jr c,prgerr

prgcopc ld bc,(prgcopt)
        inc b
        ld a,(dsksid)
        cp b
        jp nz,prgcop7
        inc c
        ld a,(dsktrk)
        cp c
        jp nz,prgcop6
        ld hl,prgmsgsuc
        ld b,1+128
        jr prgerr0

;DE=DSK-ID-String -> ZF=1 stimmt berein
prgcop1 ld hl,dskbuffer
        ld b,dsktxtlen
prgcop2 ld a,(de)
        cp (hl)
        ret nz
        inc hl
        inc de
        djnz prgcop2
        xor a
        ret


;### PRGERR -> Disc-Error-Fenster anzeigen
;### Eingabe    CF=1 -> A=Fehlercode, CF=0 -> Fehler beim DSK-Laden (Ende vorzeitig erreicht) -> Error ausgeben und zurck zum Mainloop
prgerr  jr c,prgerr4
        ld a,stoerrend
prgerr4 add a
        ld l,a
        ld h,0
        ld de,prgmsgerrtb
        add hl,de
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        ld (prgmsgerra),hl
        ld hl,prgmsgerr
        ld b,1
prgerr0 push hl
        push bc
        ld a,(prgcops)
        inc a
        jp z,prgerr1
        dec a
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILCLO
prgerr1 call fdcmof
        ld hl,prgtxtsta1
        ld (prgobjsta1),hl
        ld hl,prgtxtsta2
        ld (prgobjsta2),hl
        ld e,15
        call prgerr3
        call prgerr2
        pop bc
        pop hl
        jp prginf0
prgerr2 ld e,16
prgerr3 ld c,MSC_DSK_WININH
        ld a,(prgwin)
        ld b,a
        jp msgsnd

;### PRGSRC -> Source auswhlen
prgsrc  ld a,1
        ld hl,prginpsrca
        call prgbro
        jp prgprz0

;### PRGBRO -> Browse-Fenster ffnen
;### Eingabe    A=Typ (1=Source, 2=Destination), HL=Textinput
prgbron db 0
prgbro  ld e,a
        ld a,(prgbron)
        or a
        ret nz
        ld a,e
        ld (prgbron),a
        ld (prgmsgb+8),hl
        ld hl,(prgbnknum)
        ld h,8
        ld (prgmsgb+6),hl
        ld hl,100
        ld (prgmsgb+10),hl
        ld hl,5000
        ld (prgmsgb+12),hl
        ld l,MSC_SYS_SELOPN
        ld (prgmsgb),hl
        jp prginf2

;### PRGBRC -> Browse-Fenster schlieen
;### Eingabe    P1=Typ (0=Ok, 1=Abbruch, 2=FileAuswahl bereits in Benutzung, 3=kein Speicher frei, 4=kein Fenster frei), P2=PfadLnge
prgbrc  ld hl,(prgmsgb+1)
        inc l
        jr z,prgbrc2
        ld hl,prgbron
        ld e,(hl)
        ld (hl),0
        ld hl,(prgmsgb+1)           ;L=Typ, H=Pfadlnge
        ld a,l
        or a
        jp nz,prgprz0
        ld ix,prginpsrc
        ld e,6
        ld (ix+8),h
        xor a
        ld (ix+2),a
        ld (ix+3),a
        ld (ix+4),a
        ld (ix+5),a
        ld (ix+6),a
        ld (ix+7),a
        ld c,MSC_DSK_WININH
        ld a,(prgwin)
        ld b,a
        call msgsnd
        jp prgprz0
prgbrc2 ld a,h
        ld (prgwindat+windatsup),a
        jp prgprz0

;### MSGGET -> Message fr Programm abholen
;### Ausgabe    CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgget  ld a,(prgprzn)
        db #dd:ld l,a           ;IXL=Rechner-Proze-Nummer
        db #dd:ld h,-1
        ld iy,prgmsgb           ;IY=Messagebuffer
        rst #08                 ;Message holen -> IXL=Status, IXH=Absender-Proze
        or a
        db #dd:dec l
        ret nz
        ld iy,prgmsgb
        ld a,(iy+0)
        or a
        jp z,prgend
        scf
        ret

;### MSGDSK -> Message fr Programm von Desktop-Prozess abholen
;### Ausgabe    CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgdsk  call msgget
        jr nc,msgdsk            ;keine Message
        ld a,(dskprzn)
        db #dd:cp h
        jr nz,msgdsk            ;Message von anderem als Desktop-Proze -> ignorieren
        ld a,(prgmsgb)
        ret

;### MSGSND -> Message an Desktop-Prozess senden
;### Eingabe    C=Kommando, B/E/D/L/H=Parameter1/2/3/4/5
msgsnd0 ld a,(prgwin)
        ld b,a
msgsnd2 ld c,MSC_DSK_WININH
msgsnd  ld a,(dskprzn)
msgsnd1 db #dd:ld h,a
        ld a,(prgprzn)
        db #dd:ld l,a
        ld iy,prgmsgb
        ld (iy+0),c
        ld (iy+1),b
        ld (iy+2),e
        ld (iy+3),d
        ld (iy+4),l
        ld (iy+5),h
        rst #10
        ret

;### SYSCLL -> Betriebssystem-Funktion aufrufen
;### Eingabe    (SP)=Modul/Funktion, AF,BC,DE,HL,IX,IY=Register
;### Ausgabe    AF,BC,DE,HL,IX,IY=Register
sysclln db 0
syscll  ld (prgmsgb+04),bc      ;Register in Message-Buffer kopieren
        ld (prgmsgb+06),de
        ld (prgmsgb+08),hl
        ld (prgmsgb+10),ix
        ld (prgmsgb+12),iy
        push af
        pop hl
        ld (prgmsgb+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (prgmsgb+00),de      ;Modul und Funktion in Message-Buffer kopieren
        ld a,e
        ld (sysclln),a
        ld iy,prgmsgb
        ld a,(prgprzn)          ;Desktop und System-Prozessnummer holen
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        rst #10                 ;Message senden
syscll1 rst #30
        ld iy,prgmsgb
        ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        rst #18                 ;auf Antwort warten
        db #dd:dec l
        jr nz,syscll1
        ld a,(prgmsgb)
        sub 128
        ld e,a
        ld a,(sysclln)
        cp e
        jr nz,syscll1
        ld hl,(prgmsgb+02)      ;Register aus Message-Buffer holen
        push hl
        pop af
        ld bc,(prgmsgb+04)
        ld de,(prgmsgb+06)
        ld hl,(prgmsgb+08)
        ld ix,(prgmsgb+10)
        ld iy,(prgmsgb+12)
        ret

;### CLCHEX -> Wandelt HEX in Zahl um
;### Eingabe    HL=Hexstring (L=16er, H=1er bzw. L=1er, H=nichts)
;### Ausgabe    CF=1 -> unzulssiger Wert, CF=0 -> A=Wert
;### Verndert  HL
clchex  ld a,l
        call clchex0
        ret c
        ld l,a
        ld a,h
        call clchex0
        ld h,a
        ld a,l
        ccf
        ret nc
        add a:add a:add a:add a
        add h
        ret
clchex0 call clcucs
        cp "0"
        ret c
        cp "9"+1
        jr nc,clchex1
        sub "0"
        ret
clchex1 cp "A"
        ret c
        cp "Z"+1
        clc
        ret c
        sub "A"-10
        ret

;### CLCUCS -> Wandelt Klein- in Grobuchstaben um
;### Eingabe    A=Zeichen
;### Ausgabe    A=ucase(Zeichen)
;### Verndert  F
clcucs  cp "a"
        ret c
        cp "z"+1
        ret nc
        add "A"-"a"
        ret

;### CLCDEZ -> Rechnet Byte in zwei Dezimalziffern um
;### Eingabe    A=Wert
;### Ausgabe    L=10er-Ascii-Ziffer, H=1er-Ascii-Ziffer
;### Veraendert AF
clcdez  ld l,0
clcdez1 sub 10
        jr c,clcdez2
        inc l
        jr clcdez1
clcdez2 add "0"+10
        ld h,a
        ld a,"0"
        add l
        ld l,a
        ret

;### DSK-BUFFER ###############################################################

dskbuffer   db 0        ;ab hier 4096 zustzliche Bytes


;==============================================================================
;### DATEN-TEIL ###############################################################
;==============================================================================

prgdatbeg

;### Verschiedenes
prgmsginf1  db "DiskDeDumper",0
prgmsginf2  db " Version 1.1 (Build 060122pdt)",0
prgmsginf3  db " Copyright <c> 2006 SymbiosiS",0

prgwintit   db "DiskDeDumper 1.1",0

prgtxtint1  db "Please select the source DSK-file",0
prgtxtint2  db "and the destination drive.",0
prgtxtsrc   db "Source",0

prgtxtdst   db "Destination",0
prgtxtdrva  db "Drive A",0
prgtxtdrvb  db "Drive B",0

prgtxtunf   db 34,"Unformat",34,0
prgtxtunfa  db "Skip Track",0
prgtxtunfb  db "Wr. sector ID",0


prgtxtsta1  db "-",0
prgtxtsta10 db "Standard, ## tracks, # side(s)",0
prgtxtsta11 db "Extended, ## tracks, # side(s)",0
prgtxtsta2  db "-",0
prgtxtsta21 db "Copying track ##, side #",0
prgtxtsta3  db "DSK type",0
prgtxtsta4  db "Status",0

prgbuttxt1  db "Copy",0
prgbuttxt2  db "Cancel",0
prgbuttxt3  db "Info",0
prgbuttxt4  db "Search",0

prgmsgerrtb dw prgmsgerr00,prgmsgerr01,prgmsgerr02,prgmsgerr03,prgmsgerr04

prgmsgerr00 db "Error while sector read/write",0
prgmsgerr01 db "Media is write protected",0
prgmsgerr02 db "Device is not ready",0
prgmsgerr03 db "DSK file is corrupt, EOF reached",0
prgmsgerr04 db "Unsupported DSK version",0

prgmsgerr1  db "Disc error",0
prgmsgerr0  db "",0 ;"

prgmsgsuc1  db "Congratulation, the DSK file",0
prgmsgsuc2  db "has been transfered successfully",0
prgmsgsuc3  db "to your CPC drive!",0

;==============================================================================
;### TRANSFER-TEIL ############################################################
;==============================================================================

prgtrnbeg
;### PRGPRZS -> Stack fr Programm-Prozess
        ds 128
prgstk  ds 6*2
        dw prgprz
prgprzn db 0
prgmsgb ds 14

;### INFO-FENSTER #############################################################

prgmsginf  dw prgmsginf1,4*1+2,prgmsginf2,4*1+2,prgmsginf3,4*1+2,prgicnbig

;### ERROR-FENSTER ############################################################

prgmsgerr  dw prgmsgerr1,4*1+2
prgmsgerra dw prgmsgerr0,4*1+2,prgmsgerr0,4*1+2

prgmsgsuc  dw prgmsgsuc1,4*1+2,prgmsgsuc2,4*1+2,prgmsgsuc3,4*1+2,prgicnbig

;### HAUPT-FENSTER ############################################################

prgwindat dw #1501,0,64,44,192,111,0,0,192,111,192,111,192,111,prgicnsml,prgwintit,0,0,prgwingrp,0,0:ds 136+14

prgwingrp db 23,0:dw prgwinobj,0,0,256*00+00,0,0,07
prgwinobj
dw 00    ,255*256+0,2, 0,0,1000,1000,0                  ;00 Hintergrund
dw 00    ,255*256+1 ,prgobjint1,  3,03,186, 8,0         ;01 Einleitung 1
dw 00    ,255*256+1 ,prgobjint2,  3,11,186, 8,0         ;02 Einleitung 2
dw 00    ,255*256+0, 1,           3,22,186, 1,0         ;03 Linie
dw 00    ,255*256+1 ,prgobjsrc ,  3,27, 47, 8,0         ;04 Beschreibung 1
dw 00    ,255*256+1 ,prgobjdst ,  3,41, 47, 8,0         ;05 Beschreibung 2
dw 00    ,255*256+1 ,prgobjunf ,  3,55, 47, 8,0         ;06 Beschreibung 3
dw 00    ,255*256+32,prginpsrc , 51,25, 88,12,0         ;07 Textinput
dw prgsrc,255*256+16,prgbuttxt4,141,25, 48,12,0         ;08 "Search"-Button
dw 00    ,255*256+18,prgraddsta, 51,41, 45, 8,0         ;09 Radio Drive A
dw 00    ,255*256+18,prgraddstb,100,41, 45, 8,0         ;10 Radio Drive B
dw 00    ,255*256+18,prgradunfa, 51,55, 55, 8,0         ;11 Radio SkipTrack
dw 00    ,255*256+18,prgradunfb,112,55, 55, 8,0         ;12 Radio SectorID
dw 00    ,255*256+32,prginpsid ,173,53, 16,12,0         ;13 Textinput SectorID
dw 00    ,255*256+0, 1,           3,67,186, 1,0         ;14 Linie
dw 00    ,255*256+1, prgobjsta1, 51,72,138, 8,0         ;15 Typ    Anzeige
dw 00    ,255*256+1, prgobjsta2, 51,82,138, 8,0         ;16 Status Anzeige
dw 00    ,255*256+1, prgobjsta3,  3,72, 47, 8,0         ;17 Typ    Beschreibung
dw 00    ,255*256+1, prgobjsta4,  3,82, 47, 8,0         ;18 Status Beschreibung
dw 00    ,255*256+0, 1,           3,93,186, 1,0         ;19 Linie
dw prgcop,255*256+16,prgbuttxt1, 41,96, 48,12,0         ;20="Copy"-Button
dw prgend,255*256+16,prgbuttxt2, 91,96, 48,12,0         ;21="Cancel"-Button
dw prginf,255*256+16,prgbuttxt3,141,96, 48,12,0         ;22="Info"-Button

prgobjint1 dw prgtxtint1,4+2
prgobjint2 dw prgtxtint2,4+2

prgobjsta1 dw prgtxtsta1,4+2+128
prgobjsta2 dw prgtxtsta2,4+2+128
prgobjsta3 dw prgtxtsta3,4+2
prgobjsta4 dw prgtxtsta4,4+2

prgobjsrc  dw prgtxtsrc,4+2
prginpsrc  dw prginpsrcb,0,0,0,0,255,0
prginpsrca db "dsk",0
prginpsrcb ds 256

prginpsid  dw prginpsidb,0,2,0,2,2,0
prginpsidb db "FE",0

prgobjdst  dw prgtxtdst,4+2
prgobjunf  dw prgtxtunf,4+2

prgradkoo   ds 4
dskdrv      db 0
prgraddsta  dw dskdrv,prgtxtdrva,0*256+2+4,prgradkoo
prgraddstb  dw dskdrv,prgtxtdrvb,1*256+2+4,prgradkoo

prgradkoo2  ds 4
unftyp      db 1
prgradunfa  dw unftyp,prgtxtunfa,0*256+2+4,prgradkoo2
prgradunfb  dw unftyp,prgtxtunfb,1*256+2+4,prgradkoo2

prgtrnend

relocate_table
relocate_end
